package gg.malloc.defense.engine;

import gg.malloc.defense.model.Spawner;
import gg.malloc.defense.model.Spawnpoint;
import gg.malloc.defense.model.Arena;

import org.bukkit.entity.Entity;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Mob;

public class GameSpawner implements Spawner {
  Arena m_arena;
  MobManager m_manager;
  PlayerManager m_players;
  LivingEntity m_bombTarget;
  int m_spawnIdx = 0;

  public GameSpawner(Arena arena, MobManager manager, PlayerManager players, LivingEntity bombTarget) {
    m_arena = arena;
    m_manager = manager;
    m_players = players;
    m_bombTarget = bombTarget;
  }

  @Override
  public Entity spawnMob(EntityType type) {
    Spawnpoint[] spawnpoints = m_arena.spawnpoints();
    m_spawnIdx %= spawnpoints.length;
    //m_log.fine("Spawning " + type + " at " + spawnpoints[m_spawnIdx]);
    Entity newMob = m_arena.getWorld().spawnEntity(spawnpoints[m_spawnIdx].getLocation(), type);
    LivingEntity livingMob = (LivingEntity)newMob;
    livingMob.setRemoveWhenFarAway(false);
    m_manager.addEntity(newMob);
    m_spawnIdx += 1;
    ((Mob)newMob).setTarget(m_bombTarget);
    return newMob;
  }
}
