package gg.malloc.defense.engine;

import java.util.HashSet;

import org.bukkit.entity.Entity;
import org.bukkit.event.entity.EntityDamageEvent;

import gg.malloc.defense.model.Game;

public class MobManager {
  HashSet<Entity> m_livingMobs = new HashSet<>();
  int m_createdMobs = 0;
  int m_killedMobs = 0;

  Game m_game;

  MobManager(Game game) {
    m_game = game;
  }

  public void handleEntityDamage(EntityDamageEvent evt) {
    Entity entity = evt.getEntity();
    //m_log.info("Damage " + entity);
    //m_log.info("Living Mobs " + m_livingMobs);
    if (m_livingMobs.contains(entity)) {
      m_game.onMobDamaged(entity);
    }
  }

  public boolean contains(Entity entity) {
    return m_livingMobs.contains(entity);
  }

  public boolean killMob(Entity entity) {
    if (m_livingMobs.contains(entity)) {
      m_killedMobs += 1;
      return m_livingMobs.remove(entity);
    }
    return false;
  }

  public void clear() {
    for(Entity e : m_livingMobs) {
      e.remove();
    }
    m_livingMobs.clear();
    m_createdMobs = 0;
    m_killedMobs = 0;
  }

  public int createdMobs() {
    return m_createdMobs;
  }

  public int killedMobs() {
    return m_killedMobs;
  }

  public int remainingMobs() {
    return m_createdMobs - m_killedMobs;
  }

  public double progress() {
    return (double)m_killedMobs / (double)m_createdMobs;
  }

  public void addEntity(Entity entity) {
    //m_log.fine("Registered new mob " + entity); 
    m_livingMobs.add(entity);
    m_createdMobs += 1;
  }

  public boolean empty() {
    return m_livingMobs.size() == 0;
  }
}
